function annt=cvannt(x,y,f,hnmax,tmax,ntest)

% function annt=cvannt(x,y,f,hnmax,tmax,{ntest})
% Creeates ntest ANNs (CVHID) excludind one case at a time
% if ntest is not provided it will test all cases

ny=length(y(:,1));	% # cases
[oo,nn]=sort(rand(ny,1));

if nargin<6|ntest>ny	% if ntest is not provided or ntest is too large
   ntest=ny;
else
   nn=nn(1:ntest);
end

xo=x;yo=y;nn=sort(nn);

annt.anno=cvhid(x,y,f,hnmax,tmax); % cross-validated using all data
annt.erro=[];

for i=1:length(nn)
   x=xo;y=yo;
   ni=nn(i)	% the case to be excluded
   y(ni,:)=[];x(ni,:)=[];
   annt.anns(i).ann=cvhid(x,y,f,hnmax,tmax);
   annt.anns(i).ni=ni;
   annt.erro=[annt.erro;[ni,annt.anns(i).ann.erro.train,annt.anns(i).ann.erro.test]];
end