function ann=cvcompoe(ann,x,traintxt,testtxt)

% function ann=cvcompoe(ann,{x},{traintxt},{testtxt})
% creates a subclass COMPOE
% where train and test y,
% COMPOE.OBS and  COMPOE.PRED
% are matched with new x-axis
% CVASK is ran automatically at the
%	function's onset

if nargin<3
   traintxt=[];
   testtxt=[];
end

if nargin==1
   x=(1:length(ann.x.x(:,1)))';
end

if (nargin==4)*(isempty(x))
   x=(1:length(ann.x.x(:,1)))';
end

ann=cvask(ann);
yp=cvpreve(ann,ann.x.x);	% unscaled predictions
ann.compoe.yp=yp;
ntrain=length(ann.p.train);	% # train cases
ntest=length(ann.p.test);	% # test cases

% COMPOE train data
ann.compoe.ytrain=[];
%ann.compoe.ytrainName=[];
ann.compoe.yptrain=[];
ann.compoe.xtrain=[];
%ann.compoe.xtrainName=[];
for i=1:ntrain
   j=ann.p.train(i);	% The indexes of the train subset data
   ann.compoe.ytrain=[ann.compoe.ytrain;ann.y.y(j,:)];
   ann.compoe.yptrain=[ann.compoe.yptrain;yp(j,:)];
   ann.compoe.xtrain=[ann.compoe.xtrain;x(j,:)];
end
%ann.compoe.ytrainName=[ann.compoe.ytrainName;ann.y.trainName(:)];
%ann.compoe.xtrainName=[ann.compoe.ytrainName;ann.y.trainName(:)];
% COMPOE test data
ann.compoe.ytest=[];
ann.compoe.ytestName=[];
ann.compoe.yptest=[];
ann.compoe.xtest=[];
%ann.compoe.xtestName=[];
for i=1:ntest
   j=ann.p.test(i);	% The indexes of the test subset data
   ann.compoe.ytest=[ann.compoe.ytest;ann.y.y(j,:)];
   ann.compoe.yptest=[ann.compoe.yptest;yp(j,:)];
   ann.compoe.xtest=[ann.compoe.xtest;x(j,:)];

end
%ann.compoe.ytestName=[ann.compoe.ytestName;ann.y.testName(:)];
%ann.compoe.xtestName=[ann.compoe.xtestName;ann.x.testName(:)];
if nargin==4
   s=[ann.compoe.xtrain,ann.compoe.ytrain,ann.compoe.yptrain];
   save(traintxt,'s','-ascii')
   s=[ann.compoe.xtest,ann.compoe.ytest,ann.compoe.yptest];
   save(testtxt,'s','-ascii')
end
