function [ana,r]=cvcriana(x,hn,opt)

% function ana=cvcriana(x,hn,{opt})
% Main function for autoassociative networks
% with hn hidden nodes
% opt sets autoassociation for 
% opt(1) = 1 (default) multidimensional scaling
% opt(1) = 2 principal curve analysis
% opt(2) = hundereds of regression itherations 
%           (default=10 --> 1000 itherations)

if nargin<3;opt=[1,10];end

% 1. Creates ann variable in netlab format
[n,m]=size(x);

ana=cvcriann2(x,x,hn,0);


% 2. Trains ann 

options = zeros(1,18);	% initiazes vector of output options for NETLAB
options(14)=100;  % training epochs for each loop
options(1)=-1; % do not display warning: see help scg
errata=[];

disp('Correlation between original and demapped input values')
disp('   (each column corresponds to a parameter)')

y=cvpreve(ana,ana.x.x);
for j=1:m
    rr=corrcoef(ana.x.x(:,j),y(:,j));
    r(1,j)=rr(2,1);
end
disp(strcat('0 : ',char(32),num2str(r(1,:))));

for i=1:opt(2)
    ana.net=netopt(ana.net,options,ana.x.train,ana.y.train,'scg');
    y=cvpreve(ana,ana.x.x);
    for j=1:m
        rr=corrcoef(ana.x.x(:,j),y(:,j));
        r(i+1,j)=rr(2,1);
    end
    disp(strcat(num2str(i*options(14)),' : ','  ',num2str(r(i+1,:))));
end


    