function ann=cvcriann2(x,y,hn,f);

% function ann=cvcriann2(x,y,hn,f);
% Creates neural network ann
% with one hidden layer with hn nodes
% where f is the fraction excluded for testing
% ann.x.x= input data, x
% ann.x.sx= scalled x, to 0-1 
% ann.x.train= input kept for training
% ann.x.test= input excluded for testing
% ann.x.mm= scaling in ( between 0 and 1 )
% ann.y.y= output data, x
% ann.y.sy= scalled y, to 0-1 
% ann.y.train= output kept for training
% ann.y.test= output excluded for testing
% ann.y.mm= scaling in ( between 0 and 1 )
% ann.p.train= position of train cases (vertical vector)
% ann.p.test= position of test cases (vertical vector)
% ann.net= network in NETLAB format
% ann.f= fraction excluded for testing

% 1. reading the data

% 1.1 Sizing it
[nx,mx]=size(x);
[ny,my]=size(y);
if nx~=ny;error('ERROR: input and output have different # cases !');end
ann.x.x=x;	% keeping original input
ann.y.y=y;	% keeping original output

% 1.2. scalling it
% function y=scala(x,mmx,mmy)
ann.x.mm=[min(x);max(x)];
ann.y.mm=[min(y);max(y)];
ann.x.sx=cvscala(ann.x.x,ann.x.mm,[zeros(1,mx);ones(1,mx)]);
ann.y.sy=cvscala(ann.y.y,ann.y.mm,[zeros(1,my);ones(1,my)]);

% 2. creating the position vector
pos=[1:nx]';

% 3. Extracting training and test subsets
% function [xtrain,xtest]=extrai(x,f)

pxy.s=[pos,ann.x.sx,ann.y.sy];
%[pxy.test,pxy.train,pxy.testName,pxy.trainName]=cvxtrai(pxy.s,f);
[pxy.test,pxy.train]=cvxtrai(pxy.s,f);
% 3.1. recover train subset
ann.p.train=pxy.train(:,1);	% positions

ann.x.train=pxy.train(:,2:mx+1);	% train input data
%ann.x.trainName=pxy.trainName(:);	% train input data Name
ann.y.train=pxy.train(:,mx+2:mx+my+1);	% train output data 
%ann.y.trainName=pxy.trainName(:);	% train output data Name

% 3.2. recover test subset
ann.p.test=pxy.test(:,1);	% positions
ann.x.test=pxy.test(:,2:mx+1);	% test input data
%ann.x.testName=pxy.testName(:);	% test input data Name

ann.y.test=pxy.test(:,mx+2:mx+my+1);	% test output data
%ann.y.testName=pxy.testName(:);	% test output data Name

% 4. Creates net in NETLAB format  <---------- NET CREATED HERE !!!

ann.net = mlp(mx,hn,my,'logistic');	% CREATES ANN !
cd /home/chapmanb/client_tbox/;
% 5 MIS

ann.f=f;		% just for the reccord, what was the exact value of f
