function [mann,yp,s]=cvmann(x,y,nomex,nomey,f,hnmax,tmax)

% function [mann,yp,s]=cvmann(x,y,{nomex},{nomey},{f},{hnmax},{tmax})
% creates MULTIPLE ann to relate inputs x with outputs y
% for median network of each output
% nomex and nomey are txt file names where the labels where stored

% to make sure the pseudo-random number is not always reset to the same state
rand('seed',now);


tmax=500;hnmax=30;

if nargin<5
    f=1/7;
end

%dira=dir;
%ndir=length(char(dira.name));
ha_nomex=0;ha_nomey=0;
%nomestodos=char(dira.name);
disp('testx');
testx=exist('nomesdex.txt')
disp('testy');
testy=exist('nomesdey.txt')
 

   if testx~=0
      ha_nomex=1;
   end         
   
   if testy~=0
      ha_nomey=1;
   end

if ha_nomey==0
   nomey='nomesdey.txt';
   fid=fopen(nomey,'w');
   for i=1:length(y(1,:))
      fprintf(fid,'%s\n',strcat('output_',num2str(i)));
   end
   fclose(fid);
end

if ha_nomex==0
   nomex='nomesdex.txt';
   fid=fopen(nomex,'w');
   for i=1:length(x(1,:))
      fprintf(fid,'%s\n',strcat('input_',num2str(i)));
   end
   fclose(fid);
end

mann=cvmhid1(x,y,f,hnmax,tmax);	% create and train neural network

% Sensitvities
for i=1:length(mann)
   s(:,i)=mann(i).ann.s;
   mann(i).ann.anns=[];	% <--- Eliminates all but the median ann for each output
end

sums=sum(s);
for i=1:length(s(:,1))
   s(i,:)=(s(i,:)./(sums+(sums==0))).*(1-(sums==0));	% normalization of sensitivities
end

% predicted and obtained, train and test
for i=1:length(mann)
   ann=cvcompoe(mann(i).ann);
   yp(:,(i*2-1))=cvpreve(ann);
   yp(ann.p.test,(i*2))=1;
end

% add variable labels

mann=cvnomeia(mann,'nomesdex.txt','nomesdey.txt');

% calculates mann.stats - simple statistics

for i=1:length(mann)	% for each output (equivalent .. for each ann)
   % x stats
   mx=length(mann(i).ann.x.x(1,:));
   mann(i).stats.x.avg=cvscala(mean(mann(i).ann.x.x),ann.x.mm,[zeros(1,mx);ones(1,mx)]);
   mann(i).stats.x.sd=cvscala(std(mann(i).ann.x.x),ann.x.mm,[zeros(1,mx);ones(1,mx)]);
   % ystats
   % Calculation of confidance intervals for p=0.05 (can be changed)
   
   r=ann.compoe.yp-ann.y.y;
   [r,dt]=memb(r); % Note that r is reused to save memory, memb determines the distributionof residuals
   mann(i).stats.y.int=[interp1(dt(:,2),dt(:,1),0.025),interp1(dt(:,2),dt(:,1),0.975)];
end


