function [mann,yp,s]=cvmannual(x,y,nomex,nomey,hn,ith,nn,epochs)

% CVMANUAL manual trainign of neural nets (with no cross validation, and with no hidden node optimization)
% function [mann,yp,s]=cvmannual(x,y,nomex,nomey,hn)
% creates MULTIPLE ann to relate inputs x with outputs y
% for median network of each output
% nomex and nomey are txt file names where the labels where stored

% to make sure the pseudo-random number is not always reset to the same state
if nargin<7
    mann=[];
    epochs=100;
else
    mann=nn.mann;
    x=nn.mann(1).ann.x.x;
    y=nn.dt.x(:,[end-length(nn.nome_y)+1:end]);
end
rand('seed',now);
f=0;
if nargin<6
    ith=[1:length(y(1,:))];
end
ha_nomex=0;ha_nomey=0;
%nomestodos=char(dira.name);
%disp('testx');
testx=exist('nomesdex.txt');
%disp('testy');
testy=exist('nomesdey.txt');
if testx~=0;ha_nomex=1;end         
if testy~=0;ha_nomey=1;end

if ha_nomey==0
   nomey='nomesdey.txt';
   fid=fopen(nomey,'w');
   for i=1:length(y(1,:))
      fprintf(fid,'%s\n',strcat('output_',num2str(i)));
   end
   fclose(fid);
end
if ha_nomex==0
   nomex='nomesdex.txt';
   fid=fopen(nomex,'w');
   for i=1:length(x(1,:))
      fprintf(fid,'%s\n',strcat('input_',num2str(i)));
   end
   fclose(fid);
end
 f_options=foptions;
 f_options(14)=epochs;
%train mann
for i=ith
   
   %mann(i).ann=cvhid(x,y(:,i),f,hnmax,tmax);
   mann(i).ann=cvcriann2(x,y(:,i),hn,f);	% Creates ann
   %mann(i).ann.x.x=[mann(i).ann.x.x;mann(i).ann.x.x];
   %mann(i).ann.y.y=[mann(i).ann.y.y;mann(i).ann.y.y];
   %mann(i).ann.x.sx=[mann(i).ann.x.x;mann(i).ann.x.x];
   %mann(i).ann.y.sy=[mann(i).ann.y.y;mann(i).ann.y.y];
   mann(i).ann.x.test=mann(i).ann.x.train;
   mann(i).ann.y.test=mann(i).ann.y.train;
   mann(i).ann.p.test=mann(i).ann.p.train;
   mann(i).ann.net=netopt(mann(i).ann.net,f_options,mann(i).ann.x.train,mann(i).ann.y.train,'scg');
   mann(i).ann=cvask(mann(i).ann);
   mann(i).ann.s=cvsensa(mann(i).ann);   
   mann(i).stats.r=corrcoef(mann(i).ann.y.ptest,mann(i).ann.y.y);mann(i).stats.r=mann(i).stats.r(2,1);        
   [mann(i).stats.c2,mann(i).stats.p]=chi2(mann(i).ann.y.y,mann(i).ann.y.ptest);
   mann(i).ann.net.epochs=epochs;
end


% Sensitvities
for i=1:length(mann)
   s(:,i)=mann(i).ann.s;
   mann(i).ann.anns=[];	% <--- Eliminates all but the median ann for each output
end

sums=sum(s);
for i=1:length(s(:,1))
   s(i,:)=(s(i,:)./(sums+(sums==0))).*(1-(sums==0));	% normalization of sensitivities
end

% predicted and obtained, train and test
[n,m]=size(y);
yp=zeros(n,2*m);
for i=1:length(mann)
   %ann=cvcompoe(mann(i).ann);
   yp(:,(i*2-1))=cvpreve(mann(i).ann);
   %yp(:,(i*2-1))=mann(i).ann.y.ptrain;
end

% add variable labels

mann=cvnomeia(mann,'nomesdex.txt','nomesdey.txt');

% calculates mann.stats - simple statistics

for i=1:length(mann)	% for each output (equivalent .. for each ann)
   % x stats
   mx=length(mann(i).ann.x.x(1,:));
   mann(i).stats.x.avg=cvscala(mean(mann(i).ann.x.x),mann(i).ann.x.mm,[zeros(1,mx);ones(1,mx)]);
   mann(i).stats.x.sd=cvscala(std(mann(i).ann.x.x),mann(i).ann.x.mm,[zeros(1,mx);ones(1,mx)]);
   % ystats
   % Calculation of confidance intervals for p=0.05 (can be changed)
   
   r=mann(i).ann.y.ptrain-mann(i).ann.y.y;
   [r,dt]=memb(r); % Note that r is reused to save memory, memb determines the distributionof residuals
   mann(i).stats.y.int=[interp1(dt(:,2),dt(:,1),0.025),interp1(dt(:,2),dt(:,1),0.975)];
end