function [h,ana]=cvmap(ana,opt)

% function h=cvmap(ana,opt)
% Extracts map nodes from autoassociative
% neural net, ana. The number of coordinate (h)
% columns was set when ana was created
% by function CVCRIANA
% opt=0 --> no plot
% opt=1 (default) --> plot coordinates
% opt=2 --> plot demapped and mapped

if nargin<2;opt=1;end

[ana.y.ptrain,h]=mlpfwd(ana.net,ana.x.train);

if opt==1
    [n,m]=size(h);
    for i=1:n
        texto(i)={num2str(i)};
    end
    if m>3
        warning('plot of map coordinates was not performed because there are more than 3 dimensions')
    elseif m==3
        plot3(h(:,1),h(:,2),h(:,3),'-w.');
        text(h(:,1),h(:,2),h(:,3),texto)
        title('Multidimensional scalling with autoassociative neural networks')
        xlabel('first mapping node')
        ylabel('second mapping node')
        zlabel('thirdmapping node')
    elseif m==2        
        plot(h(:,1),h(:,2),'-w.');
        text(h(:,1),h(:,2),texto)
        title('Multidimensional scalling with autoassociative neural networks')
        xlabel('first mapping node')
        ylabel('seccond mapping node')
    else
        plot(h,'o');
        title('Multidimensional scalling with autoassociative neural networks')
        xlabel('position in data series')
        ylabel('single mapping node')
    end
end

