function cvreportm(mann,reporttxt,opcao,nx)

% function cvreport(mann,reporttxt,opcao,nx)
% stores observations / predictions in 
% "report.txt" file, distinguishing training and testing
% sensitivities are included too
% (opcao default is 1 --> report on ANN
% opcao= 2 --> report on prediction
%
% nx, new data, necessary if opcao=2
%
% default reporttxt="report.txt"

if nargin<2;reporttxt='report1.txt';end
if nargin<3;opcao=1;end
if nargin<4;nx=[];end

if opcao==1
   %if exist(reporttxt)==2;delete(reporttxt);end
   reporttxt
   fid=fopen(reporttxt,'w');
   fid2=fopen('rsM.txt','a')
   fid3=fopen('senM.txt','a')
   
   fprintf(fid,'%s\n',date);
   %fprintf(fid,'%s\n',strcat('Ref.:',cvonde));
   fprintf(fid,'%s\n',strcat('Ref.: ',reporttxt(21:end-3)));
   for i=1:length(mann)
      fprintf(fid,'%s\n','---------------------------------------------');
      fprintf(fid,'%s\n',strcat('Output Variable:	',mann(i).nomey));
      fprintf(fid,'%s\n','---------------------------------------------');
      fprintf(fid,'%s\n',strcat('#  input nodes:	',num2str(mann(i).ann.net.nin)));
      fprintf(fid,'%s\n',strcat('#  hidden nodes:	',num2str(mann(i).ann.net.nhidden)));
      fprintf(fid,'%s\n',strcat('#  output nodes:	',num2str(mann(i).ann.net.nout)));
      xx=[[mann(i).ann.y.train;mann(i).ann.y.test],[mann(i).ann.y.ptrain;mann(i).ann.y.ptest]];
      lala=std((xx(:,2)-xx(:,1)));
      xx=cvscala(xx,[0,0;1,1],[mann(i).ann.y.mm,mann(i).ann.y.mm]);
      rr=corrcoef(xx);
      fprintf(fid,'%s\n',strcat('#  R^2:	',num2str(rr(2,1)^2)));
      fprintf(fid2,'%s\n',strcat(num2str(rr(2,1)^2)));
      fprintf(fid,'%s\n',strcat('#  StDev:	',num2str(std((xx(:,2)-xx(:,1)))),'		','fraction of value span:	',num2str(lala*100),'%'));
      fprintf(fid,'%s\n','#  Estimated confidence intervals (p=0.05, using residuals):	');
      fprintf(fid,'%s\n',strcat('#  (add to predicted values):	',num2str(mann(i).stats.y.int)));
      fprintf(fid,'%s\n',strcat('#  number of cases:	',num2str(length(xx(:,1)))));
      %ybruto=mann(i).ann.y.y;dbruto=max(ybruto)-minybrutomann(i).stats.y
      fprintf(fid,'%s\n','  ');
      [treino,teste]=cvplot(mann(i).ann,4);
      fprintf(fid,'%s\n','>> training dataset in median ANN <<');
      fprintf(fid,'%s\n','obtained	predicted');
      %fprintf(fid,'%s\n',treino)
      for k=1:length(treino(:,1));
         fprintf(fid,'%s\n',strcat(num2str(k),'.	',num2str(treino(k,:))));
      end
      fprintf(fid,'%s\n','  ');
      fprintf(fid,'%s\n','>> test dataset in median ANN <<');
      fprintf(fid,'%s\n','obtained	predicted');
      %fprintf(fid,'%s\n',teste)
      for k=1:length(teste(:,1));
         fprintf(fid,'%s\n',strcat(num2str(k),'.	',num2str(teste(k,:))));
      end
      fprintf(fid,'%s\n','  ');
      fprintf(fid,'%s\n','sensitivity to inputs');
      for j=1:length(mann(i).ann.nomex)
         fprintf(fid3,'%s\n',num2str(mann(i).ann.s(j)*100));
          fprintf(fid,'%s\n',strcat(char(mann(i).ann.nomex(j).nome),': ',num2str(mann(i).ann.s(j)*100),'%'));
      end
      fprintf(fid,'%s\n','  ');
      fprintf(fid,'%s\n','-------------- advanced users ---------------');
      fprintf(fid,'%s\n','Weights of Neural Network (last column contains biases)');
      w1=[mann(i).ann.net.w1;mann(i).ann.net.b1]';
      fprintf(fid,'%s\n','  ');
      fprintf(fid,'%s\n','First layer (w1):');
      for j=1:length(w1(:,1));
         fprintf(fid,'%s\n',num2str(w1(j,:)));
      end
      w2=[mann(i).ann.net.w2;mann(i).ann.net.b2]';
      fprintf(fid,'%s\n','  ');
      fprintf(fid,'%s\n','Second layer (w2):');
      for j=1:length(w2(:,1));
         fprintf(fid,'%s\n',num2str(w2(j,:)));
      end
      fprintf(fid,'%s\n','  ');
      fprintf(fid,'%s\n','Scaling of inputs to [0 1]');
      fprintf(fid,'%s\n',strcat('min: ',num2str(mann(i).ann.x.mm(1,:))));
      fprintf(fid,'%s\n',strcat('max: ',num2str(mann(i).ann.x.mm(2,:))));
      fprintf(fid,'%s\n','  ');
      fprintf(fid,'%s\n','Scaling of output from [0 1]');
      fprintf(fid,'%s\n',strcat('min: ',num2str(mann(i).ann.y.mm(1))));
      fprintf(fid,'%s\n',strcat('max: ',num2str(mann(i).ann.y.mm(2))));
      fprintf(fid,'%s\n','  ');
   end
   fprintf(fid,'%s\n','---------------------------------------------');
   fclose(fid);

elseif opcao==2
   %if exist(reporttxt)==2;delete(reporttxt);end
   fid=fopen(reporttxt,'w');
   [y,int,nov]=cvmpreve(mann,nx);
   fprintf(fid,'%s\n',date);
   fprintf(fid,'%s\n',strcat('Ref.: ',reporttxt(21:end-3)));
   %fprintf(fid,'%s\n',strcat('Ref.:',cvonde));
   fprintf(fid,'%s\n','---------------------------------------------');
   fprintf(fid,'%s\n','New input values:');
   nomesdex=char(mann(1).ann.nomex(1).nome);
   for i=2:length(mann(1).ann.nomex)
      nomesdex=strcat(nomesdex,'	',mann(1).ann.nomex(i).nome);
   end
   fprintf(fid,'%s\n',nomesdex);
   for k=1:length(nx(:,1));
      fprintf(fid,'%s\n',[num2str(k),'. ',num2str(nx(k,:))]);
   end
   fprintf(fid,'%s\n','---------------------------------------------');
   fprintf(fid,'%s\n','Corresponding Predicted Outputs:');
   nomesdey=char(mann(1).nomey);
   for i=2:length(mann)
      nomesdey=strcat(nomesdey,'	',mann(i).nomey);
   end
   fprintf(fid,'%s\n',nomesdey);
   for k=1:length(y(:,1));
      fprintf(fid,'%s\n',[num2str(k),'. ',num2str(y(k,:))]);
   end
   fprintf(fid,'%s\n','---------------------------------------------');
   fprintf(fid,'%s\n','Estimated standard deviation of predictions:');
   desvpad=[];
   for k=1:length(mann)
      xx=[[mann(k).ann.y.train;mann(k).ann.y.test],[mann(k).ann.y.ptrain;mann(k).ann.y.ptest]];
      xx=cvscala(xx,[0,0;1,1],[mann(k).ann.y.mm,mann(k).ann.y.mm]);
      desvpad=[desvpad,std((xx(:,1)-xx(:,2)))];
   end
   fprintf(fid,'%s\n',num2str(desvpad));
   fprintf(fid,'%s\n','Estimated confidence intervals (p=0.05, using residuals):');
   fprintf(fid,'%s\n','lower boundary (add to predicted values)');
   fprintf(fid,'%s\n',num2str(int(1,:)));
   fprintf(fid,'%s\n','upper boundary (add to predicted values)');
   fprintf(fid,'%s\n',num2str(int(2,:)));
   fprintf(fid,'%s\n','---------------------------------------------');
   fprintf(fid,'%s\n','Corresponding Novelty Indexes');
   for k=1:length(nov(:,1))
      fprintf(fid,'%s\n',[num2str(k),'. ',num2str(nov(k,:))]);
   end
   fprintf(fid,'%s\n','---------------------------------------------');
   fprintf(fid,'%s\n','Sensitivity Analysis');
   fprintf(fid,'%s\n',' ');
   for j=1:length(mann);
      fprintf(fid,'%s\n','....................................');
      fprintf(fid,'%s\n',strcat('Output Variable:	',mann(j).nomey));
      fprintf(fid,'%s\n','....................................');
      [s1,s2,s3]=cvsensa(mann(j).ann,nx);
      fprintf(fid,'%s\n','Cumulative sensitivities to each input:');
      fprintf(fid,'%s\n',nomesdex);
      fprintf(fid,'%s\n',strcat(num2str(100*(s1')),' %'));
      fprintf(fid,'%s\n','individual sensitivities to each input:');
      fprintf(fid,'%s\n',strcat('	',nomesdex));
      for k=1:length(s3(:,1))
         fprintf(fid,'%s\n',[num2str(k),'.  ',num2str(s3(k,:))]);
      end
   end
   fprintf(fid,'%s\n','---------------------------------------------');
   fclose(fid);
end

