function ann=cvscan(ann,tmax)

% function ann=cvscan(ann,tmax)
% version of cvstop that scans all epochs
% up to the maximum value tmax

options = zeros(1,18);	% initiazes vector of output options for NETLAB
s=50;	% salto 0
smin=5;	% salto minimo
options(14)=s;  % training epochs
options(1)=-1; % do not display warning: see help scg
errata=[];	% initializing error history

% Initial run of ANN
t=0;
net0=ann.net;
ann=cvask(ann);e0=ann.erro.test;					% ERR=Ett=Etrain*Etest <----- ERROR DEF!!!
errata=[errata;[t,ann.erro.tt,ann.erro.train,ann.erro.test]];

% First run
t=1;
nets(t).net=netopt(net0,options,ann.x.train,ann.y.train,'scg');
ann.net=nets(t).net;ann=cvask(ann);
errata=[errata;[t,ann.erro.tt,ann.erro.train,ann.erro.test]];

% Remaining runs
for t=2:tmax
   nets(t).net=netopt(nets(t-1).net,options,ann.x.train,ann.y.train,'scg');
   ann.net=nets(t).net;ann=cvask(ann);
   errata=[errata;[t,ann.erro.tt,ann.erro.train,ann.erro.test]];
end

% Find minumum
[e,ind] = sort(errata(:,4));
ann.net=nets(ind(1)+1).net;ann=cvask(ann);

% Save errata
ann.erro.errata=errata;