function ann=cvstop(ann,tmax)

% function ann=cvstop(ann,tmax)
% trains ANN with specified # hidden nodes
% + with STOP CRITERIA or epochs > tmax

options = zeros(1,18);	% initiazes vector of output options for NETLAB
s=50;	% salto 0
smin=5;	% salto minimo
options(14)=s;  % training epochs
options(1)=-1; % do not display warning: see help scg
errata=[];	% initializing error history
	

% Initial run of ANN
t=0;
net0=ann.net;
ann=cvask(ann);e0=ann.erro.test;					% ERR=Ett=Etrain*Etest <----- ERROR DEF!!!
errata=[errata;[t,ann.erro.tt,ann.erro.train,ann.erro.test]];

% First optimization attempt
t=options(14);
net1=netopt(net0,options,ann.x.train,ann.y.train,'scg');
ann.net=net1;ann=cvask(ann);e1=ann.erro.test;
errata=[errata;[t,ann.erro.tt,ann.erro.train,ann.erro.test]];

% First evaluation
% 		if first shoot is already too far 
%		decrease step until it's close enough
w_decide=[(e1>e0)*(s>smin)*(t<tmax)];
while w_decide>0	
   ss=s;
   s=round(s*0.4);options(14)=s;
   t=t-(ss-s);	% to keep track of the training epoch
   net1=netopt(net0,options,ann.x.train,ann.y.train,'scg');
   ann.net=net1;ann=cvask(ann);e1=ann.erro.test;
   errata=[errata;[t,ann.erro.tt,ann.erro.train,ann.erro.test]];
   w_decide=[(e1>e0)*(s>smin)*(t<tmax)];
end

net=net0;

% Now e1 should be < e0, or s is too small
w1_decide=(s>smin)*(t<tmax);
while w1_decide>0
   s=round(s*1.2);options(14)=s;t=t+s;
   net2=netopt(net1,options,ann.x.train,ann.y.train,'scg');
   ann.net=net2;ann=cvask(ann);e2=ann.erro.test;
   errata=[errata;[t,ann.erro.tt,ann.erro.train,ann.erro.test]];
   % defined at this point: net0,1,2 and e0,1,2
   w2_decide=(e2>e1)*(s>smin)*(t<tmax);
   while w2_decide>0	% then, net1 has to be redefined closer to net0
      ss=s;
      s=round(s*0.4);options(14)=s;
      t=t-(ss-s);	% to keep track of the training epoch
	   net1=netopt(net0,options,ann.x.train,ann.y.train,'scg');
   	ann.net=net1;ann=cvask(ann);e1=ann.erro.test;
   	errata=[errata;[t,ann.erro.tt,ann.erro.train,ann.erro.test]];
    w2_decide=(e2>e1)*(s>smin)*(t<tmax);
   end
   net=net0;
   net1=net2;net0=net1;
   e1=e2;
   w1_decide=(s>smin)*(t<tmax);
end

ann=cvask(ann);
ann.erro.errata=errata;
