function ann=cvstops(ann,tmax,stops)

% function ann=cvstops(ann,tmax,{stops})
% resamples test data set and runs
% CVSTOP consecutively + returns the MEDIAN performer 

% ann=cvstop(ann,tmax)
if nargin<3
   stops=round(1/ann.f);
   stops=stops+((stops/2)==round(stops/2));% make it an odd number of tries
end
stoperr=[];
anns=[];

%disp([ann.net.nhidden,stops,1])
anns(1).ann=cvstop(ann,tmax);	% first try
stoperr=[stoperr;[anns(1).ann.erro.tt,anns(1).ann.erro.train,anns(1).ann.erro.test]];

for i=2:stops	% second, third ... try
   %disp([ann.net.nhidden,stops,i])
   anns(i).ann=cvcriann2(ann.x.x,ann.y.y,ann.net.nhidden,ann.f);	% recreate ann
   anns(i).ann=cvstop(anns(i).ann,tmax);
   stoperr=[stoperr;[anns(i).ann.erro.tt,anns(i).ann.erro.train,anns(i).ann.erro.test]];
end

% Find median network
[s,i]=sort(-stoperr(:,3)); % sorting by the test error !
n=length(i);
nn=i(round(n/2));	% the index of the median performer

ann=anns(nn).ann;
ann.anns=anns;