function [xtest,xtrain,xtestName,xtrainName]=cvxtrai(x,f)
%specimens =textread('Date.txt', '%s');
% function [xtest,xtrain]=cvxtrai(x,f)
%
% (Cross-validation extension to NETLAB)
% randomly samples x for a fraction, f
% to be used as a test dataset
% {The default value for f is 0.1}

if nargin==1
   f=0.1;
end

[n,m]=size(x);

nt=round(f*n);		% nt = number of rows in the test subset xtest
xtest=zeros(nt,m);

for i=1:nt
   ii=round(rand*(n-i+1.5));
   if ii>(n-i+1)		% in case rand=0.5
      ii=n-i+1;		% then index = last row of x
   elseif ii<1
      ii=1;
   end
   xtest(i,:)=x(ii,:);	% extraction of rows
   %xtestName(i,:)=specimens(ii);  %extraction of names
   x(ii,:)=[];				% x gets smaller as rows are extracted
end
xtrain=x;
%xtrainName=specimens(x);
xx=x(:,1);
%xtrainName=specimens(xx);
