function [y,dt]=memb(xo,dt)

% function [y,dt]=memb(xo,dt)
% builds membership function
% xo: raw data
% y: xo represented as membership
% dt: distribution (two column matrix)
%     if not provided it will be calculated

if nargin<2
   x=sort(xo(:));
   n=length(x);
   sx=(0:(1/(n-1)):1)';
   % Cut repeats
   for i=n-1:-1:1
      if x(i)==x(i+1)
         sx(i)=[];
         x(i)=[];
      end
   end
   % rescaling between 0 and 1
   sx=sx-sx(1);
   dt=[x,sx/(max(sx))];
end

[n,m]=size(xo);
for i=1:m
   y(:,i)=interp1q(dt(:,1),dt(:,2),xo(:,i));
end
