function y=scala(x,mmx,mmy)

% function y=scala(x,mmx,mmy)
% linear scalling of x --> y
% such that their ranges are
% mmx and mmy, respectively,
% where mm is the double row matrix:
%                          [min;max]
%
% y = miny + (x-minx) * (maxy - miny)/(maxx-minx)

[n,m]=size(x);
y=zeros(n,m);

% no change in scale if max==min any given column
mmx(2,:)=mmx(2,:)+(mmx(1,:)==mmx(2,:));
mmy(2,:)=mmy(2,:)+(mmy(1,:)==mmy(2,:));

for i=1:n
   y(i,:)=mmy(1,:)+(x(i,:)-mmx(1,:)).*(mmy(2,:)-mmy(1,:))./(mmx(2,:)-mmx(1,:));
end


